clc
close all
clear all


%upload of the data
[data_pr,CH4_composition]=upload_data();

%division of the data according to T values
number_of_T=count_T_values(data_pr);

%generation of an array of tables for eache value of temperature
data_array=data_subdivision(data_pr,number_of_T);

%average T calculation
table_T=T_avg(number_of_T,data_array); 

y1=CH4_composition/100; %CH4
y2=1-y1; %H2
critprop1=input_Properties('CH4'); %CH4
critprop2=input_Properties('H2'); %H2

R=0.08314; %barm3/(kmolK)

rho_PR=cell(number_of_T,2);

check_valuesPR=zeros(3,number_of_T);
min_valuesPR=zeros(2,number_of_T);
 

flag_plot="false";
flag_histogram="false";

nameEos="PR";

optFun=1;


flag_opt="omegaA";

    switch flag_opt  
        case "bip"
            bip=cell(number_of_T,1);

            for i=1:number_of_T
                 omegaA_v=0.1:0.02:1;   
                 omegaB_v=0.01:0.002:0.1; 
                  [result,rho_EoSf]=singleOpt(table_T{i},data_array{i},y1,y2,critprop1,critprop2,R,nameEos,optFun,flag_opt);
                 bip{i,1}=result;
                 rho_PR{i,1}=rho_EoSf;
                 plot3D(bip{i,1},omegaA_v,omegaB_v,table_T{i},i,number_of_T,flag_opt);
               %  plotAAD(bip{i,1},AAD_vector,table_T{i},i,number_of_T);
            end
               multipleMatrix(bip,"bip",bip,"bip",i,number_of_T);

        case "omegaA"
            omegaA=cell(number_of_T,1);
           
            omegaA_opt=zeros(number_of_T,1);
            omegaB_opt=zeros(number_of_T,1);
            bip_opt=zeros(number_of_T,1);
            
            rowIndex=zeros(number_of_T,1);
            colIndex=zeros(number_of_T,1);
            min_value=zeros(number_of_T,1);
            for i=1:number_of_T

                    
                 omegaB_v=0.01:0.002:0.1;
                 %bip_v=-0.15:0.05:0.05;   
                % omegaB_v=0.01:0.01:0.05;   
                 %omegaB_v=0.01:0.002:0.1;
                 %bip_v=-0.15:0.05:0.05;     
                 bip_v=-1:0.0444:1;
            
                
                 [result,rho_EoSf]=singleOpt(table_T{i},data_array{i},y1,y2,critprop1,critprop2,R,nameEos,optFun,flag_opt);
                 rho_PR{i,1}=rho_EoSf;
                 omegaA{i,1}=result;
                plot3D(bip_v,omegaA{i,1},omegaB_v,table_T{i},i,number_of_T,flag_opt);
                % plotAAD(omegaA{i,1},"omegaA",AAD_vector,table_T{i},i,number_of_T);
%                    AADf{i,1}=AAD;
% [min_Value(i,1), linearIndex] = min(AADf{i,1}(:));
% [rowIndex(i,1), colIndex(i,1)] = ind2sub(size(AADf{i,1}), linearIndex);
% omegaA_opt(i,1)=omegaA{i,1}(rowIndex(i,1),colIndex(i,1));
% omegaB_opt(i,1)=omegaB_v(rowIndex(i,1));
% bip_opt(i,1)=bip_v(colIndex(i,1));
              %  [min_values(i,1), min_index(i,1)] = min(AAD{i,1});
                % Trova il valore minimo e il relativo indice
              %  minAAD{i,1}= find(AAD_vector == min_value);  % Trova gli indici di tutti i minimi
%                  omegaA_opt(i,1)=omegaA{i,1}(min_index(i,1),1);
%                  omegaB_opt(i,1)=omegaB{i,1}(min_index(i,1),1);
%                  bip_opt(i,1)=bip_v(1,min_index(i,1));

            end
            multipleMatrix(omegaA,"omegaA",omegaA,"omegaA",i,number_of_T);

        case "omegaB"
            omegaB=cell(number_of_T,1);
            for i=1:number_of_T
                 
    
                 omegaA_v=0.1:0.02:1;
                 bip_v=-1:0.0444:1;
    
    
                 [omegaB{i,1},rho_EoSf]=singleOpt(table_T{i},data_array{i},y1,y2,critprop1,critprop2,R,nameEos,optFun,flag_opt);
                 rho_PR{i,1}=rho_EoSf;
                 plot3D(bip_v,omegaA_v,omegaB{i,1},table_T{i},flag_opt);
                 %plotAAD(omegaB{i,1},"omegaB",AAD_vector,table_T{i},i,number_of_T);

            end
                 multipleMatrix(omegaB,"omegaB",number_of_T);

        case "omegaAB"
            omegaA=cell(number_of_T,1);
            omegaB=cell(number_of_T,1);
            AAD=cell(number_of_T,1);
            omegaA_opt=zeros(number_of_T,1);
            omegaB_opt=zeros(number_of_T,1);
            bip_opt=zeros(number_of_T,1);
            
            min_index=zeros(number_of_T,1);
            min_value=zeros(number_of_T,1);
             for i=1:number_of_T
  
                 bip_v=-1:0.0444:1;
    
                
                 [omegaA{i,1},omegaB{i,1},rho_EoSf,AAD_vector]=doubleOpt(table_T{i},data_array{i},y1,y2,critprop1,critprop2,R,nameEos,optFun,flag_opt);
                 rho_PR{i,1}=rho_EoSf;
                 doublePlot(bip_v,omegaA{i,1},omegaB{i,1},table_T{i},i,number_of_T);
                %plotAAD(omegaA{i,1},"omegaA",omegaB{i,1},"omegaB",AAD_vector,table_T{i},i,number_of_T);
                 AAD{i,1}=AAD_vector;

%                 [min_values(i,1), min_index(i,1)] = min(AAD{i,1});
%                 % Trova il valore minimo e il relativo indice
%               %  minAAD{i,1}= find(AAD_vector == min_value);  % Trova gli indici di tutti i minimi
%                  omegaA_opt(i,1)=omegaA{i,1}(min_index(i,1),1);
%                  omegaB_opt(i,1)=omegaB{i,1}(min_index(i,1),1);
%                  bip_opt(i,1)=bip_v(1,min_index(i,1));
                 
             end
                multipleMatrix(omegaA,"omegaA",omegaB,"omegaB",number_of_T);
                
  
    end

    

  
  


